//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Cancellation.CancelController
{
    
    
    /// <summary>
    /// Class that implements the ICancelController interface through SiLA2
    /// </summary>
    public partial class CancelControllerClient : ICancelController
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.core.commands.cancelcontroller.v1.CancelController";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public CancelControllerClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Cancel a specified currently running Observable Command or cancel all currently running Commands (Observable and
        /// Unobservable).
        /// For any canceled Observable Command the SiLA Server MUST update the Command Execution Status to "Command Finished
        /// with Error".
        /// The SiLA Server MUST throw a descriptive error message indicating cancellation as the reason for the Command
        /// execution not being able to finish successfully for any canceled Command.
        /// </summary>
        /// <param name="commandExecutionUUID">The Command Execution UUID according to the SiLA Standard.</param>
        public virtual void CancelCommand(Uuid commandExecutionUUID)
        {
            CancelCommandRequestDto request = new CancelCommandRequestDto(commandExecutionUUID, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core.commands/CancelController/v1/Command/CancelCommand");
            try
            {
                _channel.ExecuteUnobservableCommand<CancelCommandRequestDto>(_serviceName, "CancelCommand", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex, ConvertCancelCommandException);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of CancelCommand to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertCancelCommandException(string errorIdentifier, string errorMessage)
        {
            if ((errorIdentifier == "org.silastandard/core.commands/CancelController/v1/DefinedExecutionError/InvalidC" +
                "ommandExecutionUUID"))
            {
                return new InvalidCommandExecutionUUIDException(errorMessage);
            }
            if ((errorIdentifier == "org.silastandard/core.commands/CancelController/v1/DefinedExecutionError/Operatio" +
                "nNotSupported"))
            {
                return new OperationNotSupportedException(errorMessage);
            }
            return null;
        }
        
        /// <summary>
        /// Cancels all currently running Observable and Unobservable Commands running on this SiLA Server.
        /// The SiLA Server MUST throw an Execution Error indicating 'cancellation' as the reason for the
        /// Command not being able to finish successfully.
        /// </summary>
        public virtual void CancelAll()
        {
            CancelAllRequestDto request = new CancelAllRequestDto(null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core.commands/CancelController/v1/Command/CancelAll");
            try
            {
                _channel.ExecuteUnobservableCommand<CancelAllRequestDto>(_serviceName, "CancelAll", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Cancel Controller.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class CancelControllerClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/core.commands/CancelController/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(ICancelController);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new CancelControllerClient(channel, executionManager);
        }
    }
}

